// Klasse, die Zahlenfolgen realisiert
class ZahlenfolgenFrage extends Frage {
	int[] zahlen; // vorgegebene Zahlen

	int folgeZahl; // korrekte Zahl der Zahlenfolge

	ZahlenfolgenFrage(int punkte, int[] zahlen, int folgeZahl) {
		super(
				"Identifizieren Sie die Zahlenfolge und geben Sie die nchste Zahl der Folge ein!",
				punkte);
		this.zahlen = zahlen;
		this.folgeZahl = folgeZahl;
	}

	// Frage auf den Bildschirm ausgeben
	@Override
	void frageStellen() {
		super.frageStellen();
		for (int z = 0; z < this.zahlen.length; z++) {
			IO.print(this.zahlen[z] + " ");
		}
	}

	// Frage beantworten durch Prfling, Antwort auswerten
	// und Punkte vergeben
	@Override
	void frageBeantworten(Pruefling person) {
		int eingabe = IO.readInt();
		if (eingabe == this.folgeZahl) {
			IO.println("Richtige Antwort: " + this.punkte + " Punkte");
			person.neuePunkte(this.punkte);
		} else {
			IO.println("Falsche Antwort: 0 Punkte!");
			IO.println("Richtige Antwort ist " + this.folgeZahl);
		}
	}
}

public class UE19Aufgabe3 {

	// Hauptprogramm
	public static void main(String[] args) {
		Pruefung klausur = new Pruefung();
		klausur.vorbereiten();
		klausur.durchfuehren();
		klausur.ergebnisseBekanntgeben();
	}

	Quiz pruefung;

	Pruefling[] studenten;

	UE19Aufgabe3() {
		this.pruefung = null;
		this.studenten = null;
	}

	void vorbereiten() {
		IO.println("Fragen eingeben");
		IO.println("----------------");
		String titel = IO.readString("Titel des Quizes: ");
		int anzahl = IO.readInt("Anzahl Fragen: ");
		this.pruefung = new Quiz(titel, anzahl);
		// Fragen eingeben
		for (int i = 0; i < anzahl; i++) {
			Frage f = this.frageErzeugen(i + 1);
			this.pruefung.neueFrage(f);
		}
	}

	public Frage frageErzeugen(int nummer) {
		// spaeter Factory-Pattern
		int typ = IO
				.readInt("Fragetyp: Wahr/Falsch (1), Multiple Choice (2), Zahlenfolgen (3)?");
		switch (typ) {
		case 1:
			return this.erzeugeWahrFalschFrage(nummer);
		case 2:
			return this.erzeugeMCFrage(nummer);
		case 3:
		default:
			return this.erzeugeZahlenfolgeFrage(nummer);
		}
	}

	private Frage erzeugeWahrFalschFrage(int nummer) {
		String text = IO.readString("Frage " + nummer + ": ");
		boolean wahr = IO.readChar("Wahr/falsch(w/f)?") == 'w';
		int punkte = IO.readInt("Erreichbare Punkte: ");
		return new WahrFalschFrage(text, punkte, wahr);
	}

	private Frage erzeugeMCFrage(int nummer) {
		String text = IO.readString("Frage " + nummer + ": ");
		int anzahl = IO.readInt("Anzahl an Antworten: ");
		String[] antworten = new String[anzahl];
		for (int i = 0; i < anzahl; i++) {
			antworten[i] = IO.readString("Antwort " + i + ": ");
		}
		int richtigIndex = IO.readInt("Index der richtigen Antwort: ");
		int punkte = IO.readInt("Erreichbare Punkte: ");
		return new MCFrage(text, punkte, antworten, richtigIndex);
	}

	private Frage erzeugeZahlenfolgeFrage(int nummer) {
		IO.println("Frage " + nummer + " (Zahlenfolgen ergaenzen)");
		int anzahl = IO.readInt("Anzahl an vorgegebenen Zahlen: ");
		int[] zahlen = new int[anzahl];
		for (int i = 0; i < anzahl; i++) {
			zahlen[i] = IO.readInt("Zahl " + i + ": ");
		}
		int folgeZahl = IO.readInt("Korrekte Folgezahl: ");
		int punkte = IO.readInt("Erreichbare Punkte: ");
		return new ZahlenfolgenFrage(punkte, zahlen, folgeZahl);
	}

	void durchfuehren() {
		IO.println("Pruefung");
		IO.println("--------");
		int anzahl = IO.readInt("Anzahl Prueflinge: ");
		this.studenten = new Pruefling[anzahl];
		// alle Prueflinge abfragen
		for (int i = 0; i < anzahl; i++) {
			IO.println("Pruefling " + (i + 1) + " ist an der Reihe");
			this.studenten[i] = new Pruefling(IO.readString("Name: "));
			Frage f = null;
			// alle Fragen der Pruefung stellen
			while ((f = this.pruefung.liefereNaechsteFrage()) != null) {
				f.frageStellen();
				f.frageBeantworten(this.studenten[i]);
			}
		}
	}

	void ergebnisseBekanntgeben() {
		this.ranglisteErstellen();
		IO.println("Pruefungsergebnisse");
		IO.println("-------------------");
		IO.println("Quiz: " + this.pruefung.getTitel());
		for (int i = 0; i < this.studenten.length; i++) {
			IO.println("Platz " + (i + 1) + ": " + this.studenten[i].getName()
					+ " mit " + this.studenten[i].getPunkte() + " Punkten");
		}
	}

	private void ranglisteErstellen() {
		// Bubblesort nach erreichten Punkten
		boolean veraendert = false;
		do {
			veraendert = false;
			for (int i = 0; i < this.studenten.length - 1; i++) {
				if (this.studenten[i].getPunkte() < this.studenten[i + 1]
						.getPunkte()) {
					Pruefling help = this.studenten[i];
					this.studenten[i] = this.studenten[i + 1];
					this.studenten[i + 1] = help;
					veraendert = true;
				}
			}
		} while (veraendert);
	}
}
