abstract class Filter {

	protected Filter vorFilter;

	public Filter() {
		this.vorFilter = null;
	}

	public Filter(Filter vorherige) {
		this.vorFilter = vorherige;
	}

	public String verarbeiten(String str) {
		if (this.vorFilter != null) {
			str = this.vorFilter.verarbeiten(str);
		}
		return str;
	}
}

class ToUpperCaser extends Filter {

	public ToUpperCaser() {
		super();
	}

	public ToUpperCaser(Filter vorheriger) {
		super(vorheriger);
	}

	@Override
	public String verarbeiten(String str) {
		str = super.verarbeiten(str);
		return str.toUpperCase();
	}
}

class SZErsetzer extends Filter {
	public SZErsetzer() {
		super();
	}

	public SZErsetzer(Filter vorheriger) {
		super(vorheriger);
	}

	@Override
	public String verarbeiten(String str) {
		str = super.verarbeiten(str);
		str = str.replaceAll("", "ss");
		return str;
	}
}

class Trimmer extends Filter {
	public Trimmer() {
		super();
	}

	public Trimmer(Filter vorheriger) {
		super(vorheriger);
	}

	@Override
	public String verarbeiten(String str) {
		str = super.verarbeiten(str);
		return str.trim();
	}
}

public class UE19Aufgabe5 {

	public static void main(String[] args) {
		Filter pipeline = new ToUpperCaser(new SZErsetzer(new Trimmer()));
		//pipeline = new Trimmer(new ToLowerCaser());
		while (true) {
			String eingabe = IO.readString("String: ");
			System.out.println(pipeline.verarbeiten(eingabe));
		}

	}

}

class ToLowerCaser extends Filter {

	public ToLowerCaser() {
		super();
	}

	public ToLowerCaser(Filter vorheriger) {
		super(vorheriger);
	}

	@Override
	public String verarbeiten(String str) {
		str = super.verarbeiten(str);
		return str.toLowerCase();
	}
}
