import java.util.ArrayList;
import java.util.Calendar;
import java.util.GregorianCalendar;

abstract class App {
	private String name;

	public App(String name) {
		this.name = name;
	}

	public String getName() {
		return this.name;
	}

	public abstract void ausfuehren();
}

class AppManagerOO {

	private ArrayList<App> apps;

	public AppManagerOO() {
		this.apps = new ArrayList<App>();
	}

	public void appHinzufuegen(App app) {
		this.apps.add(app);
	}

	public void ausfuehren() {
		while (true) {
			String appName = IO
					.readString("Welche App soll ausgefhrt werden: ");
			for (App app : apps) {
				if (app.getName().equals(appName)) {
					app.ausfuehren();
				}
			}
		}
	}
}

class UE19Aufgabe6 {

	public static void main(String[] args) {
		AppManagerOO manager = new AppManagerOO();
		manager.appHinzufuegen(new AppA("A"));
		manager.appHinzufuegen(new AppB("B"));
		manager.ausfuehren();
	}
}

class AppA extends App { // Taschenrechner
	
	public AppA(String name) {
		super(name);
	}

	public void ausfuehren() {
		int zahl1 = IO.readInt("Zahl 1: ");
		int zahl2 = IO.readInt("Zahl 2: ");
		System.out.println(zahl1 + " + " + zahl2 + " = " + (zahl1 + zahl2));
	}
}

class AppB extends App { // Uhranzeige

	public AppB(String name) {
		super(name);
	}
	
	public void ausfuehren() {
		Calendar kal = new GregorianCalendar();
		System.out.println("Es ist " + kal.get(Calendar.HOUR_OF_DAY) + " Uhr");
	}
}
