import java.util.ArrayList;

abstract class PlugIn {
	protected String name;

	public PlugIn(String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

	public abstract void starte();
}

class FlashPlugIn extends PlugIn {
	public FlashPlugIn() {
		super("flash");
	}

	public void starte() {
		System.out.println("Flash Player gestartet");
	}

}

class PDFPlugIn extends PlugIn {
	public PDFPlugIn() {
		super("pdf");
	}

	public void starte() {
		System.out.println("Adobe PDF-Reader gestartet");
	}

}

class WebBrowserOO {

	private ArrayList<PlugIn> plugIns;

	public WebBrowserOO() {
		plugIns = new ArrayList<PlugIn>();
	}

	public void registrieren(PlugIn plugIn) {
		plugIns.add(plugIn);
	}

	public void starten() {
		while (true) {
			String url = IO.readString("URL: ");
			String webseite = getWebSeite(url);
			for (PlugIn plugIn : plugIns) {
				if (webseite.contains(plugIn.getName())) {
					plugIn.starte();
				}
			}
			darstellen(webseite);
		}
	}

	private String getWebSeite(String url) {
		String seite = IO.readString("HTML-Code: ");
		return seite;
	}

	void darstellen(String webseite) {
		System.out.println(webseite);
	}
}

class UE19Aufgabe8 {
	public static void main(String[] args) {
		WebBrowserOO browser = new WebBrowserOO();
		browser.registrieren(new FlashPlugIn());
		browser.registrieren(new PDFPlugIn());
		browser.starten();
	}
}
