abstract class Funktion {

	protected Funktion vorFunktion;

	public Funktion() {
		this.vorFunktion = null;
	}

	public Funktion(Funktion vorherige) {
		this.vorFunktion = vorherige;
	}

	public double berechnen(double wert) {
		if (this.vorFunktion != null) {
			wert = this.vorFunktion.berechnen(wert);
		}
		return wert;
	}
}

class QuadratFunktion extends Funktion {

	public QuadratFunktion() {
		super();
	}

	public QuadratFunktion(Funktion vorherige) {
		super(vorherige);
	}

	@Override
	public double berechnen(double wert) {
		wert = super.berechnen(wert);
		return wert * wert;
	}
}

class WurzelFunktion extends Funktion {

	public WurzelFunktion() {
		super();
	}

	public WurzelFunktion(Funktion vorherige) {
		super(vorherige);
	}

	@Override
	public double berechnen(double wert) {
		wert = super.berechnen(wert);
		return Math.sqrt(wert);
	}
}

class SinusFunktion extends Funktion {

	public SinusFunktion() {
		super();
	}

	public SinusFunktion(Funktion vorherige) {
		super(vorherige);
	}

	@Override
	public double berechnen(double wert) {
		wert = super.berechnen(wert);
		return Math.sin(wert);
	}
}

public class UE19Aufgabe9 {

	public static void main(String[] args) {
		Funktion kette = new QuadratFunktion(new WurzelFunktion(
				new SinusFunktion()));
		// Funktion kette = new WurzelFunktion(new WurzelFunktion(new
		// QuadratFunktion()));
		while (true) {
			double wert = IO.readDouble("Wert: ");
			System.out.println(kette.berechnen(wert));
		}
	}

}
